Unit IAS2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAS1R1_p, IAS1R2_p;

function IAS2R(var TX :Array of Real; NX :Integer;
                var TY :Array of Real; NY :Integer;
                var CXY :Array of Real; NCX :Integer; NCY :Integer;
                IDX :Integer; IDY :Integer; XX :Real; YY :Real): Real;

implementation

function IAS2R(var TX :Array of Real; NX :Integer;
                var TY :Array of Real; NY :Integer;
                var CXY :Array of Real; NCX :Integer; NCY :Integer;
                IDX :Integer; IDY :Integer; XX :Real; YY :Real): Real;
var
I,J,K,L,M,N :Integer;
A :Array [0..3] of Real;
B :Array [0..3] of Real;
const
K0 :Integer = 0;
K1 :Integer = 1;
K4 :Integer = 4;
label
_10,_20;
begin
{ Result -    IAS2R  FORTRANe }
I  := IAS1R1(TX,NX,XX);
J  := IAS1R1(TY,NY,YY);
for K:=K1 to K4 do
 begin
  L  := I - K4 + K + K1;
  for M:=K1 to K4 do
   begin
    N  := J - K4 + M + K1;
    A[M-1] := CXY[(L-1)+(N-1)*NCX];
_10:
   end;
  B[K-1] := IAS1R2(TY,A,K4,IDY,YY,J,K0);
_20:
 end;
Result := IAS1R2(TX,B,K4,IDX,XX,I,K0);
exit;
end;

end.
